Subject: Re: MACVLANs really best solution? How about a bridge with multiple bridge virtual interfaces?

From: [email-masked] (Eric W. Biederman)
Date: Mon, 09 Mar 2009 09:34:02 -0700

Patrick McHardy <[email-masked]> writes:

> Eric W. Biederman wrote:
>> There are two tricky parts.
>>
>> One problem is that macvlans and the primary hardware device share the
>> same transmit queue.  So when I have a broadcast packet on the primary
>> devices queue I don't know if I have already sent it out to the
>> macvlan devices or not.
>
> So its about receiving packets on macvlan when transmitting on the
> real device? That sounds like a really hard problem that would probably
> indeed be better solved by a bridge.

Yes.  My concern is that if we hook the real device we will
software broadcast packets twice.

Now that I think about it we could call ndo_start_xmit directly
from the macvlan code, and bypass whatever hook we use to
intercept packets going out the normal device it should not
be too difficult.

Operationally it would be very nice if arp worked between a macvlan
and the real device.

Eric